<?php
// +----------------------------------------------------------------------
// | ThinkPHP [ WE CAN DO IT JUST THINK ]
// +----------------------------------------------------------------------
// | Copyright (c) 2017 http://gonn0101.com.cn All rights reserved.
// +----------------------------------------------------------------------
// | Author: 网蝈蝈 <245539558@qq.com>
// +----------------------------------------------------------------------

namespace Admin\Controller;
use Think\Controller;
use Common\Controller\AuthController;
use Think\Auth;
use Think\Model;
use Think\Db;
use OT\Database;

class GoodsController extends AuthController {
		public function goods_list()
	   		{ 
                $admin=M('goods');
				$count= $admin->order("g_id desc")->count();// 查询满足要求的总记录数
				$Page= new \Think\Page($count,C('DB_PAGENUM'));// 实例化分页类 传入总记录数和每页显示的记录数
				$show= $Page->show();// 分页显示输出
				$admin_list=$admin->order('g_id desc')->limit($Page->firstRow.','.$Page->listRows)->select();
				$this->assign('goods_list',$admin_list);
				$this->assign('page',$show);		
				$this->display();
	   		}
	   		 public function goods_add()
		   	{
		   		if(!IS_AJAX)
	           {
                 $this->display();
	           }
	           else
	           {
	           
			    $data['goods_name']=trim(I('post.goods_name', '', 'htmlspecialchars'));
			    $data['list_image']='/Uploads'.trim(I('post.list_image', '', 'htmlspecialchars'));
			    $data['goods_image']='/Uploads'.trim(I('post.goods_image', '', 'htmlspecialchars'));
			    $data['goods_integral']=trim(I('post.goods_integral', '', 'htmlspecialchars'));
			    $data['goods_details']=trim(I('post.goods_details', '', 'htmlspecialchars'));
			    $data['status']=trim(I('post.status', '', 'htmlspecialchars'));
			    $data['create_time']=time();
			   	$obj=M('goods');
                if($obj->add($data)){
                detailedlog('goods',session('admin_username'),'商品管理','添加',"$id",1);
				$this->success('添加成功',U('goods_list'),1);
               }
			   }
		   	}
		   		 public function goods_edit()
		   	{
		   		if(!IS_AJAX)
	           {
	           	$admin=M("goods")->where(array('g_id'=>I('id')))->find();
	           	$this->assign('list',$admin);
                 $this->display();
	           }
	           else
	           {
	            $data['g_id']=trim(I('post.g_id', '', 'htmlspecialchars'));
			    $data['goods_name']=trim(I('post.goods_name', '', 'htmlspecialchars'));
			    if(I('post.list_image')){
			    	  $data['list_image']='/Uploads'.trim(I('post.list_image', '', 'htmlspecialchars'));
			    }
			  if(I('post.goods_image')){
			    	 $data['goods_image']='/Uploads'.trim(I('post.goods_image', '', 'htmlspecialchars'));
			    }
			    
			    $data['goods_integral']=trim(I('post.goods_integral', '', 'htmlspecialchars'));
			    $data['goods_details']=trim(I('post.goods_details', '', 'htmlspecialchars'));
			    $data['status']=trim(I('post.status', '', 'htmlspecialchars'));
			   	$obj=M('goods');
                if($obj->save($data)){
                detailedlog('goods',session('admin_username'),'商品管理','编辑',"$id",1);
				$this->success('编辑成功',U('goods_list'),1);
                 }
			   }
		   	}
	          public function goods_del()
		   	{
	   		$id=$_REQUEST['id'];
	   		$admin=M('goods');
			$list=$admin->where("g_id='$id'")->find();
			$listimg=$list['goods_image'];
			$filepathOne=$_SERVER['DOCUMENT_ROOT'].__ROOT__.$listimg;
			if(!empty($filepathOne)){
			unlink($filepathOne);     
			}
			$listimgtwo=$list['list_image'];
			$filepathTwo=$_SERVER['DOCUMENT_ROOT'].__ROOT__.$listimgtwo;
			if(!empty($filepathTwo)){
			unlink($filepathTwo);     
			}
			$admin->where(array('g_id'=>$id))->delete();
			$this->redirect('goods_list');
		   	}

		  	public function exchangeList(){
				$comorder=M("comorder");
				$count=$comorder->alias('c')
				->join('lh_admin a on c.a_id=a.admin_id')
				->join('lh_goods g on c.goods_id=g.g_id')
				->count();
				$Page= new \Think\Page($count,4);
				$show= $Page->show();
				$exchangeList=$comorder->alias('c')->join('lh_admin a on c.a_id=a.admin_id')
				->join('lh_goods g on c.goods_id=g.g_id')
				->order('c_id desc')->limit($Page->firstRow.','.$Page->listRows)
				->select();
		  		  foreach ($exchangeList as $key => $value) {
						unset($exchangeList[$key]['admin_id']);
						unset($exchangeList[$key]['admin_gonn']);
						unset($exchangeList[$key]['admin_pwd']);
						unset($exchangeList[$key]['admin_addtime']);
						unset($exchangeList[$key]['admin_open']);
						unset($exchangeList[$key]['admin_status']);
						unset($exchangeList[$key]['admin_position']);
						unset($exchangeList[$key]['admin_integral']);
						unset($exchangeList[$key]['admin_autograph']);
						unset($exchangeList[$key]['admin_period']);
						unset($exchangeList[$key]['admin_img']);
						unset($exchangeList[$key]['create_time']);
						unset($exchangeList[$key]['goods_integral']);
						unset($exchangeList[$key]['list_image']);
						unset($exchangeList[$key]['goods_details']);
						unset($exchangeList[$key]['status']);
			            $exchangeList[$key]['order_time']=date("Y-m-d H:i:s",$value['order_time']);
		  		  }
			  	    $this->assign('exchangeList',$exchangeList);
					$this->assign('page',$show);	
					$this->display();
		  	}
		      public function admin_state()
		      {
		    	$id=I('x');
		    	if (empty($id))
		        {
		    		$this->error('订单ID不存在',U('exchangeList'),1);
		    	}
		    	$status=M('comorder')->where(array('c_id'=>$id))->getField('order_status');//判断当前状态情况
		    	if($status==1)
		        {
		    		$statedata = array('order_status'=>0);
		    		$auth_group=M('comorder')->where(array('c_id'=>$id))->setField($statedata);
		    		$this->success('此订单已处理成待收货状态',1,1);
		    	}
		        else
		        {
		    		$statedata = array('order_status'=>1);
		    		$auth_group=M('comorder')->where(array('c_id'=>$id))->setField($statedata);
		    		$this->success('此订单已处理成已领取状态',1,1);
		    	}
		    
		      }

		      public function exchange_del()
		   	{
	   		$id=$_REQUEST['id'];
	   		$admin=M('comorder');
			$admin->where(array('c_id'=>$id))->delete();
			$this->redirect('exchangeList');
		   	}

		   	public function exportExcel($expTitle,$expCellName,$expTableData){

		        $xlsTitle = iconv('utf-8', 'gb2312', $expTitle);//文件名称
		        // $fileName = $_SESSION['account'].date('_YmdHis');//or $xlsTitle 文件名称可根据自己情况设定
		        $cellNum = count($expCellName);
		        $dataNum = count($expTableData);
		        vendor("PHPExcel.PHPExcel");
		      $objPHPExcel = new \PHPExcel();
        $objWriter = new \PHPExcel_Writer_Excel2007($objPHPExcel);
        $objActSheet = $objPHPExcel->getActiveSheet();
        // 水平居中（位置很重要，建议在最初始位置）
        $objPHPExcel->setActiveSheetIndex(0)->getStyle('A')->getAlignment()->setHorizontal(\PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
        $objPHPExcel->setActiveSheetIndex(0)->getStyle('B')->getAlignment()->setHorizontal(\PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
        $objPHPExcel->setActiveSheetIndex(0)->getStyle('C')->getAlignment()->setHorizontal(\PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
        $objPHPExcel->setActiveSheetIndex(0)->getStyle('D')->getAlignment()->setHorizontal(\PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
        $objPHPExcel->setActiveSheetIndex(0)->getStyle('E')->getAlignment()->setHorizontal(\PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
        $objPHPExcel->setActiveSheetIndex(0)->getStyle('F')->getAlignment()->setHorizontal(\PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
        $objPHPExcel->setActiveSheetIndex(0)->getStyle('G')->getAlignment()->setHorizontal(\PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
        $objActSheet->setCellValue('A1', '姓名');
        $objActSheet->setCellValue('B1', '部门');
        $objActSheet->setCellValue('C1', '电话');
        $objActSheet->setCellValue('D1', '商品名称');
       // $objActSheet->setCellValue('E1', '商品图片');
        $objActSheet->setCellValue('F1', '订单状态');
        $objActSheet->setCellValue('G1', '下单时间');
        // 设置个表格宽度
        $objPHPExcel->getActiveSheet()->getColumnDimension('A')->setWidth(16);
        $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setWidth(20);
        $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setWidth(20);
        $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setWidth(20);
        //$objPHPExcel->getActiveSheet()->getColumnDimension('E')->setWidth(20);
        $objPHPExcel->getActiveSheet()->getColumnDimension('F')->setWidth(20);
        $objPHPExcel->getActiveSheet()->getColumnDimension('G')->setWidth(20);
        // 垂直居中
        $objPHPExcel->getActiveSheet()->getStyle('A')->getAlignment()->setVertical(\PHPExcel_Style_Alignment::VERTICAL_CENTER);
        $objPHPExcel->getActiveSheet()->getStyle('B')->getAlignment()->setVertical(\PHPExcel_Style_Alignment::VERTICAL_CENTER);
        $objPHPExcel->getActiveSheet()->getStyle('C')->getAlignment()->setVertical(\PHPExcel_Style_Alignment::VERTICAL_CENTER);
        $objPHPExcel->getActiveSheet()->getStyle('D')->getAlignment()->setVertical(\PHPExcel_Style_Alignment::VERTICAL_CENTER);
       // $objPHPExcel->getActiveSheet()->getStyle('E')->getAlignment()->setVertical(\PHPExcel_Style_Alignment::VERTICAL_CENTER);
        $objPHPExcel->getActiveSheet()->getStyle('F')->getAlignment()->setVertical(\PHPExcel_Style_Alignment::VERTICAL_CENTER);
          $objPHPExcel->getActiveSheet()->getStyle('G')->getAlignment()->setVertical(\PHPExcel_Style_Alignment::VERTICAL_CENTER);
        foreach($expTableData as $k=>$v){
            $k +=2;
            $objActSheet->setCellValue('A'.$k, $v['admin_username']);    
            $objActSheet->setCellValue('B'.$k, $v['admin_department']);    
            $objActSheet->setCellValue('C'.$k, $v['admin_tel']);    
            $objActSheet->setCellValue('D'.$k, $v['goods_name']);     
         
            // 图片生成
            $objDrawing[$k] = new \PHPExcel_Worksheet_Drawing();
            //$objDrawing[$k]->setPath('.'.$v['goods_image']);
            // 设置宽度高度
            $objDrawing[$k]->setHeight(80);//照片高度
            $objDrawing[$k]->setWidth(80); //照片宽度
            /*设置图片要插入的单元格*/
         //  $objDrawing[$k]->setCoordinates('E'.$k);
            // 图片偏移距离
            $objDrawing[$k]->setOffsetX(12);
            $objDrawing[$k]->setOffsetY(12);
            $objDrawing[$k]->setWorksheet($objPHPExcel->getActiveSheet());
            
            $objActSheet->setCellValue('F'.$k, $v['order_status']);
             $objActSheet->setCellValue('G'.$k, $v['order_time']);  
            // 表格高度
            $objActSheet->getRowDimension($k)->setRowHeight(80);
            
        }
		        header('pragma:public');
		        header('Content-type:application/vnd.ms-excel;charset=utf-8;name="'.$xlsTitle.'.xls"');
		        $excel_name="商品兑换信息";
		         $excelname = str_replace('+', '%20', urlencode($excel_name));
		        header("Content-Disposition:attachment;filename={$excelname}.xls");//attachment新窗口打印inline本窗口打印

		        $objWriter = \PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');  
		        $objWriter->save('php://output'); 
		        exit;   
    }
/**
     *
     * 导出Excel
     */
    function expUser(){//导出Excel
        $xlsName  = "User";
        $xlsCell  = array(
        array('admin_username','姓名'),
        array('admin_department','职务'),
        array('admin_tel','电话'),
        array('goods_image','商品图片'),
        array('goods_name','商品名称'),
        array('order_number','订单号'),
        array('order_status','订单状态'),
        array('order_time','下单时间'),
        );
        $comorder=M("comorder");
        $exchangeList=$comorder->alias('c')->join('lh_admin a on c.a_id=a.admin_id')
				->join('lh_goods g on c.goods_id=g.g_id')
				->order('c_id desc')->limit($Page->firstRow.','.$Page->listRows)
				->select();
		  		  foreach ($exchangeList as $key => $value) {
						unset($exchangeList[$key]['admin_id']);
						unset($exchangeList[$key]['admin_gonn']);
						unset($exchangeList[$key]['admin_pwd']);
						unset($exchangeList[$key]['admin_addtime']);
						unset($exchangeList[$key]['admin_open']);
						unset($exchangeList[$key]['admin_status']);
						unset($exchangeList[$key]['admin_position']);
						unset($exchangeList[$key]['admin_integral']);
						unset($exchangeList[$key]['admin_autograph']);
						unset($exchangeList[$key]['admin_period']);
						unset($exchangeList[$key]['admin_img']);
						unset($exchangeList[$key]['create_time']);
						unset($exchangeList[$key]['goods_integral']);
						unset($exchangeList[$key]['list_image']);
						unset($exchangeList[$key]['goods_details']);
						unset($exchangeList[$key]['status']);
			            $exchangeList[$key]['order_time']=date("Y-m-d H:i:s",$value['order_time']);
						if($value['order_status'] == 1){
						$exchangeList[$key]['order_status'] = '已领取';
						}else{
						$exchangeList[$key]['order_status'] = '待收货';
						}
		  		  }
        $this->exportExcel($xlsName,$xlsCell,$exchangeList);
         
       }
  	}
