<?php
// +----------------------------------------------------------------------
// | ThinkPHP [ WE CAN DO IT JUST THINK ]
// +----------------------------------------------------------------------
// | Copyright (c) 2015~2016 http://ilunhui.cn All rights reserved.
// +----------------------------------------------------------------------
// | Author: 网蝈蝈 <245539558@qq.com>
// +----------------------------------------------------------------------

namespace Admin\Controller;
use Think\Controller;
use Common\Controller\AuthController;
use Think\Auth;
use Vendor\ThinkImage\ThinkImage;

class MemberController extends AuthController {
     static function secondsToHourTwo($seconds){
        if(intval($seconds) < 60){
            $tt ="00时00分".sprintf("%02d",intval($seconds%60));
            }
        if(intval($seconds) >=60){
            $h =sprintf("%02d",intval($seconds/60));
            $s =sprintf("%02d",intval($seconds%60));
            if($s == 60){
                $s = sprintf("%02d",0);
                ++$h;
            }
            $t = "00";
            if($h == 60){
                $h = sprintf("%02d",0);
                ++$t;
            }
            if($t){
                $t  = sprintf("%02d",$t);
            }
            $tt= $t."时".$h."分".$s.'秒';
        }
        if(intval($seconds)>=60*60){
            $t= sprintf("%02d",intval($seconds/3600));
            $h =sprintf("%02d",intval($seconds/60)-$t*60);
            $s =sprintf("%02d",intval($seconds%60));
            if($s == 60){
                $s = sprintf("%02d",0);
                ++$h;
            }
            if($h == 60){
                $h = sprintf("%02d",0);
                ++$t;
            }
            if($t){
                $t  = sprintf("%02d",$t);
            }
            $tt= $t."时".$h."分".$s.'秒';
        }
       return  $seconds>0?$tt:'00时00分00秒';
    }
 static function secondsToHour($seconds){
        if(intval($seconds) < 60){
            $tt ="00.00";
                        }
        if(intval($seconds) >=60){
            $h =sprintf("%02d",intval($seconds/60));
            $s =sprintf("%02d",intval($seconds%60));
            if($s == 60){
                $s = sprintf("%02d",0);
                ++$h;
            }
            $t = "00";
            if($h == 60){
                $h = sprintf("%02d",0);
                ++$t;
            }
            if($t){
                $t  = sprintf("%02d",$t);
            }
            $tt= $t.".".$h;
        }
        if(intval($seconds)>=60*60){
            $t= sprintf("%02d",intval($seconds/3600));
            $h =sprintf("%02d",intval($seconds/60)-$t*60);
            // $s =sprintf("%02d",intval($seconds%60));
            // if($s == 60){
            //     $s = sprintf("%02d",0);
            //     ++$h;
            // }
            if($h == 60){
                $h = sprintf("%02d",0);
                ++$t;
            }
            if($t){
                $t  = sprintf("%02d",$t);
            }
            $tt= $t.".".$h;
        }
       return  $seconds>0?$tt:'00.00';
    }
    public function index(){

        $key=I('key');

        if($key&&$key!=""){
            // $map = array(
            //     // 'user_number' =>array('like', "%" . $key . "%"),
            //    
            //     // '_logic'     =>'or',
            // );
           $map['admin_username']=array('like', "%" . $key . "%");
        }
        
        $map['admin_status']=1;
        $Nowpage = $_GET['page']?$_GET['page']:1;
        // var_dump($Nowpage);die;
        $limits = 10;// 获取总条数
        $count = M('admin')->where($map)->count();//计算总页面
        $allpage = ceil($count / $limits);
        $allpage = intval($allpage);
        $lists = M('admin')->where($map)->page($Nowpage, $limits)->order('admin_id desc')->select();
        foreach($lists as $k=>$v)
        {
            $lists[$k]['admin_period']=self::secondsToHourTwo($v['admin_period']);
        }
        $this->assign('Nowpage', $Nowpage);
        $this->assign('allpage', $allpage);
        $this->assign('val',$key);
        if($_GET['page']){
            $this->success($lists);
        }
        $this->display();
    }
  public function exportExcel($expTitle,$expCellName,$expTableData){
        $xlsTitle = iconv('utf-8', 'gb2312', $expTitle);//文件名称
        // $fileName = $_SESSION['account'].date('_YmdHis');//or $xlsTitle 文件名称可根据自己情况设定
        $cellNum = count($expCellName);
        $dataNum = count($expTableData);
        vendor("PHPExcel.PHPExcel");
        $objPHPExcel = new \PHPExcel();
        $cellName = array('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','AA','AB','AC','AD','AE','AF','AG','AH','AI','AJ','AK','AL','AM','AN','AO','AP','AQ','AR','AS','AT','AU','AV','AW','AX','AY','AZ');
          for($i=0;$i<$cellNum;$i++){
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue($cellName[$i].'1', $expCellName[$i][1]);
            $objPHPExcel->getActiveSheet()->getStyle($cellName[$i].'1')->getFont()->setName('宋体')->setSize(16)->setBold(true); //字体加粗
            $objPHPExcel->getActiveSheet(0)->getRowDimension('1')->setRowHeight(30); 
            //设置列宽
            $objPHPExcel->getActiveSheet()->getColumnDimension($cellName[$i])->setWidth(30); 
        }
        for($i=0;$i<$dataNum;$i++){
            for($j=0;$j<$cellNum;$j++){
                $objPHPExcel->getActiveSheet(0)->setCellValue($cellName[$j].($i+2), $expTableData[$i][$expCellName[$j][0]]);
            }
        }

        
       //  $objPHPExcel->getActiveSheet(0)->mergeCells('A1:'.$cellName[$cellNum-1].'1');//合并单元格
       // // $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A1', $expTitle.'  Export time:'.date('Y-m-d H:i:s'));  
       //  for($i=0;$i<$cellNum;$i++){
       //      $objPHPExcel->setActiveSheetIndex(0)->setCellValue($cellName[$i].'2', $expCellName[$i][1]); 
       //  } 
       //    // Miscellaneous glyphs, UTF-8   
       //  for($i=0;$i<$dataNum;$i++){
       //    for($j=0;$j<$cellNum;$j++){
       //      $objPHPExcel->getActiveSheet(0)->setCellValue($cellName[$j].($i+3), $expTableData[$i][$expCellName[$j][0]]);
       //    }             
       //  }  
        header('pragma:public');
        header('Content-type:application/vnd.ms-excel;charset=utf-8;name="'.$xlsTitle.'.xls"');
        $excel_name="广网学院学员信息";
        $excelname = str_replace('+', '%20', urlencode($excel_name));
        header("Content-Disposition:attachment;filename={$excelname}.xls");//attachment新窗口打印inline本窗口打印
        $objWriter = \PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5');  
        $objWriter->save('php://output'); 
        exit;   
    }
/**
     *
     * 导出Excel
     */
 public   function expUser(){//导出Excel
        $xlsName  = "User";
        $xlsCell  = array(
        array('admin_gonn','工号'),
        array('admin_username','姓名'),
        array('admin_department','部门'),
        array('admin_position','职务'),
        array('admin_tel','手机号'),
        array('admin_period','总学时'),
        array('admin_integral','学分'),
         array('monperiod','月学时'),
        );
        $sldate=urldecode(I('reservation',''));//获取格式 string '2018-09-03 - 2018-09-04' (length=23)
        $arr = explode(" - ",$sldate);//转换成数组
        $thismonth_start=strtotime($arr[0]);
        $thismonth_end=strtotime($arr[1].' 23:59:59'); 
        $where['start_time'] = array('between',"$thismonth_start,$thismonth_end");
        $where['end_time']=array('between',"$thismonth_start,$thismonth_end");
        $admin=M('admin');
         $map['admin_status']=1;
          $admin_list=$admin->where($map)->select();
          $click=M("count")->field('sum(hour) as monperiod,uid')->where($where)->group('uid')->select();
            foreach ($click as $key => $v) {
            $arr[]=$v['uid'];
            }
            $newArr = array();
            foreach ($click as $k => $vv) {
            $newArr[$vv['uid']] =$vv['monperiod'];
            }
            foreach ($admin_list as $ke => &$vo) {
            if(in_array($vo['admin_id'], $arr)){
            $vo['monperiod'] =$newArr[$vo['admin_id']];
            }else{
              $vo['monperiod'] = strval(0);
            }
            }

                  function multi_array_sort($multi_array,$sort_key,$sort=SORT_DESC){
            if(is_array($multi_array)){ 
              foreach ($multi_array as $row_array){
              if(is_array($row_array)){
              $key_array[] = $row_array[$sort_key]; 
              }else{
               return false; 
               } 
                } 
            }else{
              return false; 
            } 
            array_multisort($key_array,$sort,$multi_array); 
            return $multi_array; 
            } 
            $adminList=multi_array_sort($admin_list,'monperiod',SORT_DESC);
            $adminShow=array_slice($adminList,0,800,'true');
        foreach($adminShow as $k=>$v)
        {
            $adminShow[$k]['admin_period']=self::secondsToHour($v['admin_period']);
            $adminShow[$k]['monperiod']=self::secondsToHour($v['monperiod']);
        }
        $this->exportExcel($xlsName,$xlsCell,$adminShow);
         
    }

    //会员状态
    public function member_state()
    {
    	$id=I('admin_id');
    	if (empty($id))
        {
    		$this->error('用户不存在',U('index'),1);
    	}
    	$status=M('admin')->where(array('admin_id'=>$id))->getField('open');//判断当前状态情况
    	if($status==1)
        {
    		$statedata = array('open'=>0);
    		$auth_group=M('admin')->where(array('admin_id'=>$id))->setField($statedata);
    		$this->success('状态禁止',1,1);
    	}
        else
        {
    		$statedata = array('open'=>1);
    		$auth_group=M('admin')->where(array('admin_id'=>$id))->setField($statedata);
    		$this->success('状态开启',1,1);
    	}

    }


    //添加会员
    public function add()
    {
    	if(!IS_AJAX)
        {
            $adminList=M('admin')->order("admin_id desc")->limit(1)->select();
            $this->assign('admin',$adminList[0]);
    		$this->display();
    	}
        else
        {
    		$obj=M('admin');
            $data['admin_gonn']=trim(I('post.admin_gonn', '', 'htmlspecialchars'));
            $data['admin_username']  = trim(I('post.admin_username', '', 'htmlspecialchars'));
            $data['admin_department']=trim(I('post.admin_department', '', 'htmlspecialchars'));
            $data['admin_position']=trim(I('post.admin_position', '', 'htmlspecialchars'));
            $data['admin_tel']=trim(I('post.admin_tel', '', 'htmlspecialchars'));
            $data['admin_status']=trim(I('post.admin_status', '', 'htmlspecialchars'));
            $data['createtime']=time();
            $adminLi=M('admin')->where("admin_tel={$data['admin_tel']}")->find();
            if($adminLi)
            {
              $this->error('该手机号已被其他员工绑定');
            }
    		$uid=$obj->add($data);
            $where['is_required']=1;
            $where['is_elective']=1;
            $where['_logic'] = 'or';
            $datal=M('datal')->where($where)->select();
            $course=M("course");
            foreach ($datal as $key => $v) {
              $c=array();
              $c['v_id']=$v['id'];
              $c['uidd']=$uid;
              $course->add($c);
            }
             $datali=M('datal')->select();
             $coursepp=M("coursepp");
             foreach ($datali as $key => $v) {
              $a=array();
              $a['v_id']=$v['id'];
              $a['u_id']=$uid;
              $coursepp->add($a);
            }
            detailedlog('admin和course',session('admin_username'),'学员信息管理','添加',"$uid",1);
    		$this->success('添加成功',U('index'),1);
    	}
    }

    //编辑会员
    public function edit(){

        if (!IS_AJAX){
            $adminList=M('admin')->order("admin_id desc")->limit(1)->select();
            $this->assign('adminList',$adminList[0]);
    		$admin=M('admin')->where(array('admin_id'=>I('id')))->find();
    		$this->assign('list',$admin);
    		$this->display();
        }else{
            $obj=M('admin');
            $data['admin_id']=trim(I('post.admin_id', '', 'htmlspecialchars'));
            $data['admin_username']  = trim(I('post.admin_username', '', 'htmlspecialchars'));
            $data['admin_department']=trim(I('post.admin_department', '', 'htmlspecialchars'));
            $data['admin_position']=trim(I('post.admin_position', '', 'htmlspecialchars'));
            $data['admin_tel']=trim(I('post.admin_tel', '', 'htmlspecialchars'));
            $data['admin_period']=trim(I('post.admin_period', '', 'htmlspecialchars'));
            $data['admin_integral']=trim(I('post.admin_integral', '', 'htmlspecialchars'));
            $data['admin_status']=trim(I('post.admin_status', '', 'htmlspecialchars'));
            $obj->save($data);
             detailedlog('admin',session('admin_username'),'学员信息管理',"编辑","{$data['admin_id']}",1);
            $this->success('修改成功',U('index'),1);
        }

	}

    //删除会员
    public function del(){
        $id=$_REQUEST['id'];
        $data['admin_status']=0;
        $data['deltime']=time();
        $list = M('admin')->where(array('admin_id'=>$id))->save($data);
        $course = M('course')->where(array('uidd'=>$id))->delete();
        $coursepp = M('coursepp')->where(array('u_id'=>$id))->delete();
        $share = M('share')->where(array('uid'=>$id))->delete();
        if($list){
             detailedlog('admin',session('admin_username'),'学员信息管理','删除',"$id",1);
            $this->success('删除成功');
        }else{
            $this->error('删除失败');
        }
    }


}
