<?php
// +----------------------------------------------------------------------
// | ThinkPHP [ WE CAN DO IT JUST THINK ]
// +----------------------------------------------------------------------
// | Copyright (c) 2017 http://gonn0101.com.cn All rights reserved.
// +----------------------------------------------------------------------
// | Author: 网蝈蝈 <245539558@qq.com>
// +----------------------------------------------------------------------

namespace Admin\Controller;
use Think\Controller;
use Common\Controller\AuthController;
use Think\Auth;
use Think\Model;
use Think\Db;
use OT\Database;

class QuestionController extends AuthController {
	         //题目列表
			  public function question_list()
		   		{ 
	                $admin=M('question');
					$count= $admin->order("id desc")->count();// 查询满足要求的总记录数
					$Page= new \Think\Page($count,C('DB_PAGENUM'));// 实例化分页类 传入总记录数和每页显示的记录数
					foreach($map as $key=>$val) {
						$Page->parameter[$key]=urlencode($val);
					}
					$show= $Page->show();// 分页显示输出
					$admin_list=$admin->order('id desc')->limit($Page->firstRow.','.$Page->listRows)->select();
					$this->assign('question_list',$admin_list);
					$this->assign('page',$show);		
					$this->display();
		   		}
		   	//答案列表
		     	public function answer_list()
		   		 { 
	                $admin=M('answer');
					$count= $admin->order("aid desc")->count();// 查询满足要求的总记录数
					$Page= new \Think\Page($count,C('DB_PAGENUM'));// 实例化分页类 传入总记录数和每页显示的记录数
					foreach($map as $key=>$val) {
						$Page->parameter[$key]=urlencode($val);
					}
					$show= $Page->show();// 分页显示输出
					$admin_list=$admin->order('aid desc')->limit($Page->firstRow.','.$Page->listRows)->select();
					$this->assign('answer_list',$admin_list);
					$this->assign('page',$show);		
					$this->display();
		   		 }
	   		//添加题目
		   	     public function question_add()
			   	{
			   		if(!IS_AJAX)
		           {
	                 $this->display();
		           }
		           else
		           {
					$obj=M('question');
					$data['title']=trim(I('post.title', '', 'htmlspecialchars'));
					$data['type']=trim(I('post.type', '', 'htmlspecialchars'));
					$data['create_time']=time();
			        if($id=$obj->add($data)){
			        detailedlog('question',session('admin_username'),'试题列表','添加',"$id",1);
			        $this->success('添加成功',U('Question/question_list'),1);
	              }
		         }
			   	}
		    //添加答案
			public function answer_add()
			{
			if(!IS_AJAX)
			{
				$where['type']=1;
				$question=M('question')->where($where)->order("id desc")->select();
				$this->assign('question',$question);
				$this->display("answer_add");
			}
			else
			{
				$obj=M('answer');
				$data['question_id']=trim(I('post.question_id', '', 'htmlspecialchars'));
				$data['answer']=trim(I('post.answer', '', 'htmlspecialchars'));
				$data['create_time']=time();
				if($id=$obj->add($data)){
				detailedlog('answer',session('admin_username'),'答案列表','添加',"$id",1);
				$this->success('添加成功',U('Question/answer_list'));
			    }
			  }
			}
			 //题目编辑
		    public function question_edit(){
		        if (!IS_AJAX){
		    		$admin=M('question')->where(array('id'=>I('id')))->find();
		    		$this->assign('list',$admin);
		    		$this->display();
		        }else{
					$obj=M('question');
					$data['id']=trim(I('post.id', '', 'htmlspecialchars'));
					 $data['title']=trim(I('post.title', '', 'htmlspecialchars'));
					$data['type']=trim(I('post.type', '', 'htmlspecialchars'));
		            $obj->save($data);
		             detailedlog('question',session('admin_username'),'题目列表','编辑',"{$data['id']}",1);
		            $this->success('修改成功',U('question_list'),1);
			        }
				}
				 //答案编辑
		    public function answer_edit(){
		        if (!IS_AJAX){
			        $where['type']=1;
					$question=M('question')->where($where)->order("id desc")->select();
		    		$admin=M('answer')->where(array('aid'=>I('id')))->find();
		    		$this->assign('list',$admin);
		    		$this->assign('question',$question);
		    		$this->display();
		        }else{
					$obj=M('answer');
					$data['aid']=trim(I('post.id', '', 'htmlspecialchars'));
					$data['answer']=trim(I('post.answer', '', 'htmlspecialchars'));
					$data['question_id']=trim(I('post.question_id', '', 'htmlspecialchars'));
		            $obj->save($data);
		             detailedlog('answer',session('admin_username'),'答案列表','编辑',"{$data['id']}",1);
		            $this->success('修改成功',U('answer_list'),1);
			        }
				}
	   	
      	public function question_del()
		   	{
	   		$id=$_REQUEST['id'];
	   		$question=M('question');
	   		$answer=M('answer');
			$question =$question->where(array('id'=>$id))->delete();
			$answer =$answer->where(array('question_id'=>$id))->delete();
			detailedlog('question',session('admin_username'),'试题管理','删除',"$id",1);
			$this->redirect('question_list');
		   	}
	      public function  answer_del()
		   	{
	   		$id=$_REQUEST['id'];
	   		$answer=M('answer');
			$answer =$answer->where(array('aid'=>$id))->delete();
			detailedlog('answer',session('admin_username'),'试题管理','删除',"$id",1);
			$this->redirect('answer_list');
		   	}
	   	}
